The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::BiQuad Class Reference

STK biquad (two-pole, two-zero) filter class. More...

`#include <BiQuad.h>`

Inheritance diagram for stk::BiQuad:

## Public Member Functions
| BiQuad ()
| Default constructor creates a second-order pass-through filter.
| ~BiQuad ()
| Class destructor.
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.
void | setCoefficients (StkFloat b0, StkFloat b1, StkFloat b2, StkFloat a1, StkFloat a2, bool clearState=false)
| Set all filter coefficients.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setB1 (StkFloat b1)
| Set the b[1] coefficient value.
void | setB2 (StkFloat b2)
| Set the b[2] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setA2 (StkFloat a2)
| Set the a[2] coefficient value.
void | setResonance (StkFloat frequency, StkFloat radius, bool normalize=false)
| Sets the filter coefficients for a resonance at frequency (in Hz). More...
void | setNotch (StkFloat frequency, StkFloat radius)
| Set the filter coefficients for a notch at frequency (in Hz). More...
void | setEqualGainZeroes (void)
| Sets the filter zeroes for equal resonance gain. More...
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return a reference to one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs. More...
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object. More...
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain. More...
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency. More...
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK biquad (two-pole, two-zero) filter class.

This class implements a two-pole, two-zero digital filter. Methods are provided for creating a resonance or notch in the frequency response while maintaining a constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995–2021.

## Member Function Documentation

## ◆ setResonance()

void stk::BiQuad::setResonance | ( | StkFloat | frequency,
|  | StkFloat | radius,
|  | bool | normalize = `false`
| ) |  |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. If normalize is true, the filter zeros are placed at z = 1, z = -1, and the coefficients are then normalized to produce a constant unity peak gain (independent of the filter gain parameter). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width. An unstable filter will result for radius >= 1.0. The frequency value should be between zero and half the sample rate.

## ◆ setNotch()

void stk::BiQuad::setNotch | ( | StkFloat | frequency,
|  | StkFloat | radius
| ) |  |

Set the filter coefficients for a notch at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate zeros with the given frequency (in Hz) and radius from the z-plane origin. No filter normalization is attempted. The frequency value should be between zero and half the sample rate. The radius value should be positive.

## ◆ setEqualGainZeroes()

void stk::BiQuad::setEqualGainZeroes | ( | void |  | ) |

Sets the filter zeroes for equal resonance gain.

When using the filter as a resonator, zeroes places at z = 1, z = -1 will result in a constant gain at resonance of 1 / (1 - R), where R is the pole radius setting.

## ◆ tick() [1/2]

StkFrames & stk::BiQuad::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

133{
134#if defined(_STK_DEBUG_)
135 if ( channel >= frames.channels() ) {
136 oStream_ << "BiQuad::tick(): channel and StkFrames arguments are incompatible!";
137 handleError( StkError::FUNCTION_ARGUMENT );
138 }
139#endif
140
141 StkFloat *samples = &frames[channel];
142 unsigned int hop = frames.channels();
143 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
144 inputs_[0] = gain_ * *samples;
145 *samples = b_[0] * inputs_[0] + b_[1] * inputs_[1] + b_[2] * inputs_[2];
146 *samples -= a_[2] * outputs_[2] + a_[1] * outputs_[1];
147 inputs_[2] = inputs_[1];
148 inputs_[1] = inputs_[0];
149 outputs_[2] = outputs_[1];
150 outputs_[1] = *samples;
151 }
152
153 lastFrame_[0] = outputs_[1];
154 return frames;
155}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::BiQuad::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

158{
159#if defined(_STK_DEBUG_)
160 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
161 oStream_ << "BiQuad::tick(): channel and StkFrames arguments are incompatible!";
162 handleError( StkError::FUNCTION_ARGUMENT );
163 }
164#endif
165
166 StkFloat *iSamples = &iFrames[iChannel];
167 StkFloat *oSamples = &oFrames[oChannel];
168 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
169 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
170 inputs_[0] = gain_ * *iSamples;
171 *oSamples = b_[0] * inputs_[0] + b_[1] * inputs_[1] + b_[2] * inputs_[2];
172 *oSamples -= a_[2] * outputs_[2] + a_[1] * outputs_[1];
173 inputs_[2] = inputs_[1];
174 inputs_[1] = inputs_[0];
175 outputs_[2] = outputs_[1];
176 outputs_[1] = *oSamples;
177 }
178
179 lastFrame_[0] = outputs_[1];
180 return iFrames;
181}

The documentation for this class was generated from the following file:

- BiQuad.h

The Synthesis ToolKit in C++ (STK)
©1995--2021 Perry R. Cook and Gary P. Scavone. All Rights Reserved.